seccomp_precompute(3)

NAME
seccomp_precompute - Precompute the current seccomp filter

SYNOPSIS
#include <seccomp.h>

typedef void * scmp_filter_ctx;

int seccomp_precompute(scmp_filter_ctx ctx);

Link with -lseccomp.

DESCRIPTION

Precomputes the seccomp filter for later use by seccomp_load() and similar functions. Not only does this improve performance of seccomp_load() it also ensures that the seccomp filter can be loaded in an async-signal-safe manner if no changes have been made to the filter since it was precomputed.

RETURN VALUE
Returns zero on success or one of the following error codes on failure:

-ECANCELED
    There was a system failure beyond the control of the library.

-EFAULT
    Internal libseccomp failure.

-EINVAL
    Invalid input, either the context or architecture token is invalid.

-ENOMEM
    The library was unable to allocate enough memory.

If the SCMP_FLTATR_API_SYSRAWRC filter attribute is non-zero then additional error codes may be returned to the caller; these additional error codes are the negative errno values returned by the system. Unfortunately libseccomp can make no guarantees about these return values.

EXAMPLES
#include <seccomp.h>

int main(int argc, char *argv[])
{
	int rc = -1;
	scmp_filter_ctx ctx;

	ctx = seccomp_init(SCMP_ACT_KILL);
	if (ctx == NULL)
		goto out;

	/* ... */

	rc = seccomp_precompute(ctx);
	if (rc < 0)
		goto out;

	/* ... */

	rc = seccomp_load(ctx);
	if (rc < 0)
		goto out;

	/* ... */

out:
	seccomp_release(ctx);
	return -rc;
}

NOTES

While the seccomp filter can be generated independent of the kernel, kernel support is required to load and enforce the seccomp filter generated by libseccomp.

The libseccomp project site, with more information and the source code repository, can be found at https://github.com/seccomp/libseccomp. This tool, as well as the libseccomp library, is currently under development, please report any bugs at the project site or directly to the author.

AUTHOR
Paul Moore <paul@paul-moore.com>

SEE ALSO
seccomp_load(3) signal-safety(7)